----------------------------
------------TODO------------
----------------------------

* [Feature] Temporarily color a lap or sector time as soon as it completes (as a highlight)
* [Feature] Add up/down scroll buttons for both app windows
* [Feature] Add hotkeys for app mode switching
* [Feature] Add session delta & predicted lap time
* [Feature] Invalid laps -> indicator
* [Feature] Pits -> indicator
* [Feature] Build configuration GUI
  - Add separate configurations per session type
  - Add separate configurations per mode
  - No configuration GUI, just use presets (dynamic, based on config folder structure)
* [Feature] Handle replays
* [Feature] Add graphs
* [Feature] Add drift points column
* [Feature] Handle delta timing better
* [Performance] Use COLOR_BEST type dict for all coloring
* [Performance] Don't update GUI apps when they are hidden
  - ac.addOnAppActivatedListener() and ac.addOnAppDismissedListener()
* [Performance] laps.py -> time_at_position ... use car_state.completion_race  
* [Bug] APP_LAPS -> rows get colored even if lap not reached for current car
* [Bug] car_state.py --> self.number_of_laps = info.graphics.numberOfLaps if info.graphics.numberOfLaps > 0 else 2
* [Bug] Fix RaceStatus.first_line_crossed for practice/hotlap modes
  - This should automatically fix COL_COMPLETION_LAP display
* [Bug] Fix RaceStatus.number_of_laps for practice/hotlap modes
  - Handle COL_COMPLETION_RACE display in this case (use N/A?)
* [Bug] Fix flickering of COL_COMPLETION_LAP when restarting a practice session
* [Bug] Drag Race
	KLB> Exception: Traceback (most recent call last):
	File "apps/python/ka0sleaderboard\ka0sleaderboard.py", line 43, in acUpdate
		app.on_update(dt)
	File "apps/python/ka0sleaderboard\src\application.py", line 78, in on_update
		self.cars.on_update(dt, include_leader=True, limit=self.number_of_rows)
	File "apps/python/ka0sleaderboard\src\cars.py", line 96, in on_update
		self.laps[car_id].add(car_state.completed_laps, car_state.position, time)
	File "apps/python/ka0sleaderboard\src\laps.py", line 125, in add
		self.laps[lap].add(position, time)
	File "apps/python/ka0sleaderboard\src\laps.py", line 55, in add
		if not self._is_need_to_skip(position, time):
	File "apps/python/ka0sleaderboard\src\laps.py", line 78, in _is_need_to_skip
		if time - self.times[-1] < self.resolution_ms:
	IndexError: array index out of range

----------------------------
------------DONE------------
----------------------------

* [Feature] GIT!
* [Feature] sim_info.py -> SPageFileGraphic -> (i) isInPit (ii) currentSectorIndex (iii) lastSectorTime ==> Useless
* [Performance] Fix configuration in code
* [Feature] sim_info.py -> SPageFileStatic (i) sectorCount (ii) _carModel
* [Feature] Split times in separate columns
* [Feature] App icon
  - assettocorsa\content\gui\icons
* [Feature] Colors - header rows, alternate rows, player row
* [Bug] Handle resets better (specifically deltas)
* [Performance] Remove best_mode from opponents.py
* [Performance] Clean up code in opponents.py -> calc_deltas_for_grid (i.e. methodify it, instead of repeating the same code 3x)
* [Performance] Rename classes to something more meaningful
* [Feature] Colors - best split times
* [Feature] Fix car name
  - D:\Games\SteamApps\common\assettocorsa\content\cars\abarth500\ui\ui_car.json
* [Feature] Add distance based deltas and distance driven
  - D:\Games\SteamApps\common\assettocorsa\content\tracks\nurburgring\ui\ui_track.json
* [Feature] Add user setting to manage update frequency (dt variable)
  - Perhaps have separate record and view update frequencies
* [Feature] Add modes in APP_LEADERBOARD
* [Feature] Add hotlap mode
* [Performance] Move some of the specific configuration into individual app classes
* [Feature] #WILLNOTDO# Add format string in config
* [Feature] #WILLNOTDO# Add average speed column
* [Feature] Add best/worst coloring in APP_LAPS
